library Torrent;
uses
  Math,
  SysUtils,
  DateUtils,
  Windows,
  Classes,      
  TorrentFile in 'TorrentFile.pas';
{$E wdx}
{$R *.res}
const
    ft_nomorefields=0;
    ft_numeric_32=1;
    ft_numeric_64=2;
    ft_numeric_floating=3;
    ft_date=4;
    ft_time=5;
    ft_boolean=6;
    ft_multiplechoice=7;
    ft_string=8;
    ft_fulltext=9;
    ft_datetime=10;
    //For ContentGetValue
    ft_nosuchfield=-1;
    ft_fileerror=-2;
    ft_fieldempty=-3;
    ft_ondemand=-4;
    ft_delayed=0;
    CONTENT_DELAYIFSLOW=1;  // ContentGetValue called in foreground
    //For the plugin !
    ListeElement:array[0..4]of PChar =('Files','Size of Piece','Total Size','SHA','Tracker');
    ResultatListeElement:array[0..4]of Integer =(ft_numeric_32,ft_numeric_32,ft_numeric_64,ft_string,ft_string);
    TailleTotale:PChar=('bytes|kbytes|Mbytes|GBytes');
    fieldcount:integer=5;
    TriDefaut:array[0..4]of Integer=(-1,1,-1,1,1);
{------------------------------------------------------------------------------}
procedure ContentGetDetectString(DetectString: PChar; maxlen: Integer); stdcall;
var detect:PChar;
begin
    detect:=PChar('EXT="TORRENT"');
    StrCopy(DetectString, detect);
end;
{------------------------------------------------------------------------------}
function ContentGetSupportedField(FieldIndex:integer;FieldName:pchar;Units:pchar;maxlen:integer):integer; stdcall;
begin
    if ((FieldIndex<0) OR (FieldIndex>fieldcount-1)) then Result:=ft_nomorefields;
    if ((FieldIndex>=0) AND (FieldIndex<fieldcount)) then
    begin
        StrCopy(Units,'');
        StrCopy(FieldName,ListeElement[FieldIndex]);
        if(FieldIndex=2) then StrCopy(Units,TailleTotale);
        Result:=ResultatListeElement[FieldIndex];
    end;
end;
{------------------------------------------------------------------------------}
function ContentGetValue(FileName:pchar;FieldIndex,UnitIndex:integer;FieldValue:pbyte;maxlen,flags:integer):integer; stdcall;
var
    FileTorrent:TTorrentFile;
    f:TFileStream;
    thisfile:TTorrentSubfile;
    s:string;
    i:integer;
    j:int64;
begin

    if((FieldIndex>-1) AND (FieldIndex<fieldcount)) then
    begin
        s:=FileName;
        f:=TFileStream.Create(s,fmOpenRead);
        FileTorrent:=TTorrentFile.Create;
        FileTorrent.Load(f);
        //Nbre de fichiers
        if (FieldIndex=0) then Pinteger(FieldValue)^ := FileTorrent.Files.Count;
       //Taille des pieces (Kb)
        if (FieldIndex=1) then Pinteger(FieldValue)^:=FileTorrent.PieceLength div 1024;
        //Taille Totale Kb or Mb
        if (FieldIndex=2) then
        begin
            j:=0;
            for i := 0 to FileTorrent.Files.Count -1 do begin
                thisfile :=FileTorrent.Files[i] as TTorrentSubFile;
                j:=j+thisfile.length;
            end;
            if(UnitIndex=0) then Pint64(FieldValue)^:=j;
            if(UnitIndex=1) then Pint64(FieldValue)^:=j div 1024;
            if(UnitIndex=2) then Pint64(FieldValue)^:=j div 1048576;
            if(UnitIndex=3) then Pint64(FieldValue)^:=j div (1048576*1024);
        end;
        //SHA
        if (FieldIndex=3) then StrCopy(PChar(FieldValue),PChar(FileTorrent.Hash));
        //Tracker
        if (FieldIndex=4) then StrCopy(PChar(FieldValue),PChar(FileTorrent.Announce));
        //Return the type of result}
        result:=ResultatListeElement[FieldIndex];
        //free the file
        FreeAndNil(FileTorrent);
        FreeAndNil(f);
    end;
end;
{------------------------------------------------------------------------------}
function ContentGetDefaultSortOrder(FieldIndex:integer):integer; stdcall
begin
    Result:=TriDefaut[FieldIndex];
end; 
{------------------------------------------------------------------------------}
exports
    ContentGetValue,
    ContentGetDetectString,
    ContentGetSupportedField,
    ContentGetDefaultSortOrder;
{------------------------------------------------------------------------------}
end.




